/*Dieses Programm ist zur Ansteuerung der Relaiskarte, welche es bei Conrad Elektronik
zu kaufen gibt. Um mehr Informationen zu erhalten einfach auf

http//www.thomas-dohl.de/

schauen. (Dies ist und die offizielle Homepage fuer dieses Programm.)
Dieses Programm ist copyright by Thomas Dohl.
Es ist kostenlos und darf daher nicht verkauft werden!
Der code darf natuerlich veraendert werden, aber es 
waere schoen, wann man mir Veraenderungen mitteilt.
Viel Spass mit diesem Programm.

This program is for controlling the Relaycard you can buy at Conrad electronics.
For more information, go to 

http://www.thomas-dohl.de/

It's free and may not be sold!
You can change the code ofcourse, but I would appreciate your notifying me of the changes.
Good luck with this program.

*/

/* Translated to English and
modified to include a -f switch for fast switching of a selected portnumber
by Bro */

#include <iostream>
#include <unistd.h>
#include <termios.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#include "Relaisprogramm.h"
#include <fstream>
#include <cstdlib>	// is needet for exit()

/*
#include <sys/types.h>
#include <sys/stat.h>
*/

using namespace std;

bool OPT_R=0 //Option R Relaiskartenwahl - Choose relay card
    ,OPT_S=0 //Option S Relais setzen - Switch relay
    ,OPT_I=0 //Option I Initialisiertung - Initialize
    ,OPT_D=0 //Option D Device angeben (COM Port) - Specify device
    ,OPT_G=0 //Option G Get status
    ,OPT_F=0;//Option F Fast switching (modification) - Schnell schalten
	
unsigned char eingabe_opt_s[EINGABE_OPT_S_STRINGLAENGE];

unsigned char eingabe_opt_f[EINGABE_OPT_F_STRINGLAENGE];

unsigned char empfang_einfach_daten[EMPFANG_EINFACH_DATENLAENGE];
unsigned char empfang_erweitert_daten[EMPFANG_ERWEITERT_DATEN_FELD_X][EMPFANG_ERWEITERT_DATEN_FELD_Y];
const char *comport=MODEMDEVICE;
unsigned char language=DEFAULT_LANGUAGE;

/* Hauptfunktion 
int argc gibt an, wieviele Parameter uebergeben wurden. 
    argc ist mindistens immer 1, denn in argv[0] steht immer der Name des Programmes.
char **argv ist ein Zeiger auf Feld mit den Jeweiligen Parametern

Main function
int argc tells how many parameters were given. 
   argc is at least 1, because in argv[0] is always the name of the programme.
char **argv is a pointer to the place with the current parameters.

*/
int main(int argc, char **argv)
{
    int c=0;
    unsigned char relaiskarte=0;
    if(argc==1)
    {
	L_DE{cout<<"Bitte geben Sie die Erforderlichen Parameter ein.\nFuer mehr Informationen einfach \"-h\" eingeben.\n";}
	L_EN{cout<<"Please specify the right parameter. For more information, specify \"-h\".\n";}
    }

    while ((c = getopt (argc, argv, "r:s:f:ihvgd:l:")) != -1)
    {
	switch (c)
	{
	case 'r'://Relaiskarte - Relaycard number
	    OPT_R=TRUE;
	    relaiskarte=OPT_R_1();
	    break;
	
	
	case 's'://Setzen der Relais - Enabling the relais
	    OPT_S=TRUE;
	    OPT_S_1();
	    break;
	
	case 'd'://Eingabe eines anderen Com-Portes - Specifying a different Com Port
	    OPT_D=TRUE;
	    OPT_D_1();
	    break;
	
	case 'i'://Initialisierung - Initialize
    	    OPT_I=TRUE;
    	    break;
	
	
	case 'g'://Get Status 
	    OPT_G=TRUE;
	    break;

	case 'f'://fast switching - schnell schalten
	    OPT_F=TRUE;
	    OPT_F_1();
	    break;
	case 'l':
	    language=OPT_L();
	    break;
	case 'v'://Verionsausgabe - Version Number
	    cout<<"Version: "<<VERSIONS_NUMMER<<endl;
    	    break;
	case 'h'://Ausgabe der Hilfe - Show help
	    HILFE();
	    break;

	default :
	    L_DE{cout<<"Mit \"-h\" kann man sich die Hilfe anzeigen lassen.\n"; }
	    L_EN{cout<<"You can show the help with the \"-h\" switch.\n";}
	}
    }
    
    cout<<"COM Port: \""<<comport<<"\"\n";

    if (OPT_I)
    {
        OPT_I_1();OPT_I_1(); //2 init runs for better results
    }

    if (OPT_R)
    {
        if (OPT_S)
	{
	    OPT_S_3(relaiskarte,OPT_S_2(relaiskarte));
	}
	
	if (OPT_G)
	{
	    OPT_G_1(relaiskarte);
	}

	if (OPT_F)
	{
	   OPT_S_3(relaiskarte,OPT_F_2(relaiskarte));
	}
	
    }
    

}//Ende von "main"  Hauptprogramm
//*******************************************************************************************************************************************+
void HILFE()
{
L_DE{cout<<" \
Hilfe vom Relaiskartenprogramm Version "<<VERSIONS_NUMMER<<"\n \
Folgende Optionen sind verfuegbar: \n \
  -l\tHiermit kann man die Sprache einstellen. (bitte als erstes angeben)\n \
  \t 1 = Deutsch (default)\n \
  \t 2 = Englisch \n \
  -d\tHier gibt man das Device an. (/dev/ttyS0) \n \
  -r\tHier gibt man die Nummer der Relaiskarte an (1-255) \n \
  -s\tSetzen der Relais. \n \
\tParameter: (Es muessen 8 Parameter sein!) \n \
\t\t\""<<char(ASCII_1)<<"\" Relais ausschalten \n \
\t\t\""<<char(ASCII_2)<<"\" Relais einschalten \n \
\t\t\""<<char(ASCII_3)<<"\" Relais wird gelassen, wie es aktuell ist \n \
\t\t\""<<char(ASCII_4)<<"\" Relais wird per Zufall geschalten \n \
\t\t\""<<char(ASCII_5)<<"\" Relais toggeln (z.B. vorher \"on\" danach \"off\") \n \
  -f\tSchnell schalten von Relais. Parameter 1: Relais Nummer. 2: gleich wie bei -s \n \
  -i\tInitialisierung der Relaiskarten \n \
  -g\tGibt den Aktuellen Status des angesprochenen Relais aus. \n \
  -h\tGibt diese Hilfe aus. \n \
  -v\tGibt die Versionsnummer des Programmes aus. \n \
\n  Beispiel: (vorher=alle Relais aus) \n \
\t\"Relaisprogramm.bin -d /dev/ttyS1 -r 1 -s "<<char(ASCII_1)<<char(ASCII_2)<<char(ASCII_1)<<char(ASCII_4)<<char(ASCII_1)<<char(ASCII_3)<<char(ASCII_5)<<char(ASCII_2) \
<<"\"\n\t(nachher:)  Die 1. Relaiskarte wird angesprochen \n  \
\t\""<<char(ASCII_1)<<"\" das Relais 4,6,8 wird ausgeschaltet \n \
\t\""<<char(ASCII_2)<<"\" das Relais 1,7 wird eingeschaltet \n \
\t\""<<char(ASCII_5)<<"\" das Relais 2 wird getoggelt und damit in diesem Fall eingeschalen \n \
\t\""<<char(ASCII_3)<<"\" das Relais 3 wird so gelassen, wie es jetzt ist \n \
\t\""<<char(ASCII_4)<<"\" das Relais 5 wird per Zufall geschaltet \n \
\t\t\t (vorher an nachher aus und umgedreht) \n \
\n";}

L_EN{cout<<" \
\n \
Help for Relaiskartenprogramm Version "<<VERSIONS_NUMMER<<"\n \
Following options are available: \n \
  -l\tSetting language (please use this as first option)\n \
  \t 1 = german (default)\n \
  \t 2 = english \n \
  -d\tSpecify device. (/dev/ttyS0) \n \
  -r\tSpecify the relais card number (1-255) \n \
  -s\tSwitch the relay. \n \
\tParameter: (You have to give 8 parameters!) \n \
\t\t\""<<char(ASCII_1)<<"\" Switch off relay \n \
\t\t\""<<char(ASCII_2)<<"\" Switch on relay \n \
\t\t\""<<char(ASCII_3)<<"\" Leave relay as it is \n \
\t\t\""<<char(ASCII_4)<<"\" Switch relay randomly \n \
\t\t\""<<char(ASCII_5)<<"\" Toggle relay (before \"on\" afterwards \"off\") \n \
  -f\tFast switching of relay. Parameters: 1. relay number 2. same as -s switch \n \
  -i\tInitialise the relay card \n \
  -g\tShow actual status of specified relay card. \n \
  -h\tShow this help. \n \
  -v\tShow program version number. \n \
\n  Beispiel: (vorher=alle Relais aus) \n \
\t\"Relaisprogramm.bin -d /dev/ttyS1 -r 1 -s "<<char(ASCII_1)<<char(ASCII_2)<<char(ASCII_1)<<char(ASCII_4)<<char(ASCII_1)<<char(ASCII_3)<<char(ASCII_5)<<char(ASCII_2) \
<<"\"\n\t(nachher:)  The first relay card is addressed. \n  \
\t\""<<char(ASCII_1)<<"\" Relais 4,6,8 are switched off \n \
\t\""<<char(ASCII_2)<<"\" Relais 1,7 are switched on \n \
\t\""<<char(ASCII_5)<<"\" Relay 2 is toggeled and switched on in this case \n \
\t\""<<char(ASCII_3)<<"\" Relay 3 is left untouched \n \
\t\""<<char(ASCII_4)<<"\" Relay 5 is switched randomly \n \
\t\t\t (from front to back and reversed) \n \
\n \
\n";}
}//Ende von HILFE - End of HELP
//**********************************************************************************
bool ZUFALLSZAHL()
{
bool zahl=0;
//zahl=1;//Aktivieren, wenn man das Programm debuggen will - Activate when you want to debug the programme
//zahl=0x01&time(NULL);//einfacher Zufallsgenerator - Simple random generator
ifstream indat("/dev/urandom");//Auslesen aus dem Linuxzufallsgenerator - Read from the Linux random generator
char inp[2];
if(indat)
{
    indat.getline(inp,2);
    zahl=0x01&inp[0];
}
return zahl;
}//Ende von ZUFALLSZAHL - End of RANDOMNUMBER
//**********************************************************************************
unsigned char EMPFANG_EINFACH(unsigned long loop, unsigned long timeout)
{
    if (loop==0){loop=EMPFANG_EINFACH_LOOP;}
    if (timeout==0){timeout=EMPFANG_EINFACH_TIMEOUT;}

    int fd=0, res=0;
    unsigned long zaehler=0;
    
    memset(empfang_einfach_daten,0x0,EMPFANG_EINFACH_DATENLAENGE);//leeren des Empfangspuffers - clear the read cash
    struct termios newtio;
    
    fd = open(comport, O_NDELAY | O_RDWR | O_NOCTTY); //O_RDONLY, O_WRONLY or O_RDWR -     O_NDELAY (geht weiter, wenn keine Daten da sind und gibt "-1" zurueck) -- man 2 open fuer mehr Infos - see man 2 for more info
    if (fd <0) {
	L_DE{cout<<"Fehler beim oeffnen von \""<<comport<<"\"!\n";}
	L_EN{cout<<"Error while opening of \""<<comport<<"\"!\n";}
	ENDE_FEHLER();
    }//Falls ein Fehler beim Oeffnen vom comport auftreten sollte
    bzero(&newtio, sizeof(newtio));
    newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;//setzt die neuen Porteinstellungen
    newtio.c_iflag = IGNPAR;
    newtio.c_oflag = 0;
    newtio.c_lflag = 0;		/* set input mode (non-canonical, no echo,...) */
    newtio.c_cc[VTIME] = 0;	/* inter-character timer unused */
    newtio.c_cc[VMIN] = 1;	/* blocking read until 1 chars received */
    tcflush(fd, TCIFLUSH);
    tcsetattr(fd,TCSANOW,&newtio);
    
    
    for (zaehler=0;zaehler<loop;zaehler++)
//Alte Variante, Neue unten, noch nicht komplett erprobt.
    {
	res = read(fd,empfang_einfach_daten,EMPFANG_EINFACH_DATENLAENGE);
	if (res!=-1){break;}
	usleep (timeout);
    }

/* Lese Versuch BETA Soll die obere Schleife irgendwann ersetzen
    timeval tv;
    tv.tv_sec = 0;//sekunden
    tv.tv_usec = 1000000;//microsekunden
    fd_set rs;
    FD_ZERO (&rs);
    FD_SET (fd, &rs);
    int select_ret = select (fd+1, &rs, NULL, NULL, &tv);
    if (select_ret == 1) // lesen erlaubt
    {cout << "Daten sind da.\n";
    res = read(fd,empfang_einfach_daten,EMPFANG_EINFACH_DATENLAENGE);
    }else cout << "Timeout neu\n";
*/    
#ifdef DEBUG_EMPFANG_EINFACH_1
cout<<"**** DEBUG_EMPFANG_EINFACH_1 ****\n";
cout<<"res="<<res<<endl;
for (i=0;i<EMPFANG_EINFACH_DATENLAENGE;i++)
{
    cout<<"Daten "<<i+1<<" = 0x"<<hex<<int(empfang_einfach_daten[i])<<endl<<dec;
}
#endif


    if (res==-1 || zaehler==loop) 
    {
	L_DE{cout<<"Zeitueberschreitung\n";}
	L_EN{cout<<"Timeout\n";}
	return 0;
    }
    else {return char(res);}
}//Ende von EMPFANG_EINFACH
//**********************************************************************************
unsigned int EMPFANG_ERWEITERT(unsigned long loop, unsigned long timeout)
{
    if (loop==0){loop=EMPFANG_ERWEITERT_LOOP;}
    if (timeout==0){timeout=EMPFANG_ERWEITERT_TIMEOUT;}

    int i=0,i1=0,fd=0, res=0;
    unsigned int nachrichten=0;
    unsigned long zaehler=0;
//    memset(empfang_erweitert_daten,0x0,EMPFANG_ERWEITERT_DATEN_FELD);
    for (i=0,i1=0;i<EMPFANG_ERWEITERT_DATEN_FELD_X;i++)//Das gesamt "empfang_erweitert_daten"-feld auf 0x00 setzen
    {
	for (i1=0;i1<EMPFANG_ERWEITERT_DATEN_FELD_Y;i1++)
	{
	    empfang_erweitert_daten[i][i1]=0x00;
	}
    }
    struct termios newtio;
    
    fd = open(comport, O_NDELAY | O_RDWR | O_NOCTTY); //O_RDONLY, O_WRONLY or O_RDWR -     O_NDELAY (geht weiter, wenn keine Daten da sind und gibt "-1" zurueck) -- man 2 open fuer mehr Infos
    if (fd <0) {
	L_DE{cout<<"Fehler beim oeffnen von \""<<comport<<"\"!\n";}
	L_EN{cout<<"Error while opening of \""<<comport<<"\"!\n";}
	ENDE_FEHLER();
    }//Falls ein Fehler beim Oeffnen vom comport auftreten sollte
    bzero(&newtio, sizeof(newtio));
    newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;//setzt die neuen Porteinstellungen
    newtio.c_iflag = IGNPAR;
    newtio.c_oflag = 0;
    newtio.c_lflag = 0;		/* set input mode (non-canonical, no echo,...) */
    newtio.c_cc[VTIME] = 0;	/* inter-character timer unused */
    newtio.c_cc[VMIN] = 1;	/* blocking read until 1 chars received */
    tcflush(fd, TCIFLUSH);
    tcsetattr(fd,TCSANOW,&newtio);
    for (nachrichten=0,zaehler=0;zaehler<loop;zaehler++)
    {
	res = read(fd,empfang_erweitert_daten[nachrichten],EMPFANG_ERWEITERT_DANTENLAENGE);
	if (res!=-1){zaehler=0;nachrichten++;}
	if (nachrichten>=EMPFANG_ERWEITERT_DATEN_FELD_X)
	{
	    L_DE{cout<<"Zu viele Daten empfangen!!!\n";}
	    L_EN{cout<<"To much data received!!!\n";}
	    ENDE_FEHLER();
	}
	if (res>EMPFANG_ERWEITERT_DANTENLAENGE)
	{
	    L_DE{cout<<"Die empfangenen Daten sind mehr als "<<EMPFANG_ERWEITERT_DANTENLAENGE<<"!\nEs wurden \""<<res<<"\" Daten empfangen!\n";}
	    L_EN{cout<<"Received data are more then "<<EMPFANG_ERWEITERT_DANTENLAENGE<<"!\n\""<<res<<"\" daten received!\n";}
	    ENDE_FEHLER();
	}
	usleep (timeout);
    }
    
    if (nachrichten==0)
    {
	L_DE{cout<<"Es wurden keine Daten empfangen! (Zeitueberschreitung)\n";}
	L_EN{cout<<"No data received! (timeout)\n";}
	return 0;
    }
    else {return nachrichten;}
}//Ende von EMPFANG_ERWEITERT
//**********************************************************************************
bool SENDEN(unsigned char *sende_daten,unsigned int anzahl_daten)
{
    int fd=0,n=0;
    struct termios newtio;
    
    fd = open(comport, O_RDWR | O_NOCTTY );
    if (fd < 0) {
        L_DE{cout<<"Fehler beim oeffnen von \""<<comport<<"\"!\n";}
        L_EN{cout<<"Error while opening of \""<<comport<<"\"!\n";}
        ENDE_FEHLER();
    }
    bzero(&newtio, sizeof(newtio));
    newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
    newtio.c_iflag = IGNPAR;
    newtio.c_oflag = 0;
    newtio.c_lflag = 0;
    tcflush(fd, TCIFLUSH);
    tcsetattr(fd,TCSANOW,&newtio);
    
    n = write(fd,sende_daten,anzahl_daten);
     
    if (n < 0) {
	L_DE{cout<<"Fehler beim Senden!\n";}
	L_EN{cout<<"Error while sending!\n";}
	ENDE_FEHLER();
    }
    return 1;
}//Ende von SENDEN
//**********************************************************************************
unsigned char GET_STATUS(unsigned char relaiskarte)
{
    unsigned char sende_daten[SENDEN_EINFACH_DATENLAENGE];
    sende_daten[0]=CMD_GET_PORT_S;
    sende_daten[1]=relaiskarte;
    sende_daten[2]=0;
    sende_daten[3]=(sende_daten[0]^sende_daten[1]^sende_daten[2]);
    SENDEN(sende_daten,4);
    EMPFANG_EINFACH(0,0);
    if (empfang_einfach_daten[0]==CMD_GET_PORT_R && 
	empfang_einfach_daten[3]==(empfang_einfach_daten[0]^empfang_einfach_daten[1]^empfang_einfach_daten[2]))
	{
	    return empfang_einfach_daten[2];
	}
    else {
	L_DE{cout<<"Fehler bei GET_STATUS, Fehler bei Auswertung.\n";}
	L_EN{cout<<"Error in GET_STATUS, error while analysation.\n";}
	ENDE_FEHLER();
    }
    return 0;
    
}//Ende von GET_STATUS



//**********************************************************************************
unsigned char OPT_L()
{
    int i=0, parameter_anzahl=0;
    unsigned char t_language=0;
    for (i=0;i<5;i++)
    {
	if (optarg[i]==0x00){break;}
	if (optarg[i]<0x30 || optarg[i]>0x39){
	    L_DE{cout<<"Bitte nur Zahlen eingeben!\n";}
	    L_EN{cout<<"Pleas insert numbers only!\n";}
	    ENDE_FEHLER();
	}//0x30 bis 0x39 bedeutet im ASCII-Code: 0-9
    }
    parameter_anzahl=i;
    if (parameter_anzahl<1 || parameter_anzahl>3)//Die eingegebene Zahl darf nicht groesser als 255 sein.
    {
	L_DE{cout<<"Der Parameter kann max 3 Stellen haben!\nSie haben \""<<parameter_anzahl<<"\" Stellen eingegeben.\n";}
	L_EN{cout<<"Maximum 3 places!\nYou've insert \""<<parameter_anzahl<<"\" places\n";}
	ENDE_FEHLER();
    }
    
    //Ziemlich simple Umwandlung der Char in einen Hexwert.
    if (parameter_anzahl==1){t_language=(optarg[0]-0x30);}//Wenn eine Zahl eingegeben wurde
    if (parameter_anzahl==2){t_language=(optarg[0]-0x30)*10+(optarg[1]-0x30);}//Wenn zwei Zahlen eingegeben wurden
    if (parameter_anzahl==3){t_language=(optarg[0]-0x30)*100+(optarg[1]-0x30)*10+(optarg[2]-0x30);}//Wenn drei Zahlen eingegeben wurde
//    cout<<"Language: "<<(int)t_language<<"\n";
    if(t_language<1 || t_language > 2){t_language=DEFAULT_LANGUAGE;}
    return t_language;
}
    
//**********************************************************************************
unsigned char OPT_R_1()
{
    int i=0,parameter_anzahl=0;
    unsigned char relaiskarte=0;
    for (i=0;i<MAX_PARAMETER;i++)//Zaehlt die gesamten Uebergebenen Parameter - count total number of parameters
    {
	if (optarg[i]==0x00){break;}
	if (optarg[i]<0x30 || optarg[i]>0x39){
	    L_DE{cout<<"Bitte nur Zahlen eingeben!\n";}
	    L_EN{cout<<"Please insert only numbers!\n";}
	    ENDE_FEHLER();
	}//0x30 bis 0x39 bedeutet im ASCII-Code: 0-9
    }
    parameter_anzahl=i;
    if (parameter_anzahl<1 || parameter_anzahl>3)//Die eingegebene Zahl darf nicht groesser als 255 sein.
    {
	L_DE{cout<<"Der Parameter kann max 3 Stellen haben!\nSie haben \""<<parameter_anzahl<<"\" Stellen eingegeben.\n";}
	L_EN{cout<<"Maximum 3 places!\nYou've insert \""<<parameter_anzahl<<"\" places\n";}
	ENDE_FEHLER();
    }
    
    //Ziemlich simple Umwandlung der Char in einen Hexwert.
    if (parameter_anzahl==1){relaiskarte=(optarg[0]-0x30);}//Wenn eine Zahl eingegeben wurde
    if (parameter_anzahl==2){relaiskarte=(optarg[0]-0x30)*10+(optarg[1]-0x30);}//Wenn zwei Zahlen eingegeben wurden
    if (parameter_anzahl==3){relaiskarte=(optarg[0]-0x30)*100+(optarg[1]-0x30)*10+(optarg[2]-0x30);}//Wenn drei Zahlen eingegeben wurde
    return relaiskarte;
}//Ende von OPT_R_1
//**********************************************************************************
void OPT_S_1()//Kurze Ueberpruefung der Eingabeparameter und dann kopieren in eingabe_opt_s zur spaeteren Weiterverarbeitung - Short check of input parameters and then a copy into eingabe_opt_s for later processing
{
    int i=0;
    memset(eingabe_opt_s,0x00,EINGABE_OPT_S_STRINGLAENGE);
    
    for (i=0;i<MAX_PARAMETER;i++){if (optarg[i]==0x00){break;}}//Zaehlen der Eingabeoptionen fuer -s
    
    if (i==EINGABE_OPT_S_STRINGLAENGE)
    {
	for (i=0;i<EINGABE_OPT_S_STRINGLAENGE;i++)
	{eingabe_opt_s[i]=optarg[i];}
    }
    else
    {
	L_DE{cout<<"Sie haben \""<<i<<"\" Optionen eingegeben und nicht wie erforderlich \""<<EINGABE_OPT_S_STRINGLAENGE<<"\"!\n";}
	L_EN{cout<<"You have given \""<<i<<"\" options, and not the required \""<<EINGABE_OPT_S_STRINGLAENGE<<"\"!\n";}
	ENDE_FEHLER();
    }
    
}//Ende von OPT_S_1
//**********************************************************************************
unsigned char OPT_S_2(unsigned char relaiskarte)//Verarbeitung der Eingabeparameter, welche in eingabe_opt_s gespeichert sind. - Processing of parameters wtored in eingabe_opt_s
{
    int i=0,i2=0;
    unsigned char steuerbit_neu=0,steuerbit_neu_1=0,steuerbit_alt=0;
    
    for (i=0,i2=0;i<EINGABE_OPT_S_STRINGLAENGE;i++)//Durchlaufen aller 8 Zeichen - interate over all 8 numbers
    {
	if (eingabe_opt_s[i]!=ASCII_1 && eingabe_opt_s[i]!=ASCII_2 && eingabe_opt_s[i]!=ASCII_3 && eingabe_opt_s[i]!=ASCII_4 && eingabe_opt_s[i]!=ASCII_5)//Ueberpruefung der Zeichen.
	{
	    L_DE{cout<<"Unbekannter Parameter:\""<<eingabe_opt_s[i]<<"\"\n";}
	    L_EN{cout<<"Unknown parameter\""<<eingabe_opt_s[i]<<"\"\n";}
	    ENDE_FEHLER();
	}
	if ((eingabe_opt_s[i]==ASCII_3) || (eingabe_opt_s[i]==ASCII_5)){i2++;}
    }
    
    if (i2!=0)//Wenn das "ASCII_3 oder ASCII_5" Zeichen im String vorkommt! - in case of "r" or "x"
    {
//	steuerbit_alt=0xFF; //Relaiszustand alle on: (Nur testhalber)
	steuerbit_alt=GET_STATUS(relaiskarte);//Hier wird der Aktuelle Relaistatus abgefragt.
	for (steuerbit_neu=0x00,steuerbit_neu_1=0x00,i=0;i<EINGABE_OPT_S_STRINGLAENGE;i++)//Umwandlung des Strings in ein unsigned char.
	{
	    if ((eingabe_opt_s[i]==ASCII_3)||(eingabe_opt_s[i]==ASCII_5)) {steuerbit_neu++;}//Bit auf 1 setzten, wenn "ASCII_3 oder ASCII_5" gefunden wurde, ansonsten auf 0 lassen
	    if (eingabe_opt_s[i]==ASCII_5) {steuerbit_neu_1++;}
	    if(i!=7)
	    {
		steuerbit_neu<<=1;	//Die Bits von "steuerbit_neu" um 1 nach links verschieben.
		steuerbit_neu_1<<=1;	//Die Bits von "steuerbit_neu_1" um 1 nach links verschieben.
	    }
	}
	steuerbit_alt=steuerbit_alt&steuerbit_neu;//AND-Operator
	steuerbit_alt=steuerbit_alt^steuerbit_neu_1;//XOR
    }
    
    for (steuerbit_neu=0x00,i=0;i<EINGABE_OPT_S_STRINGLAENGE;i++)//Umwandlung des Strings in ein unsigned char.
    {
	switch (eingabe_opt_s[i])//Abfrage, welches Zeichen gerade vorhanden ist.
	{
	    case ASCII_1:
		break;//Auf 0 lassen.
	    case ASCII_2:
		steuerbit_neu++;//Auf 1 setzen
		break;
	    case ASCII_3:
		break;// nichts machen, "ASCII_3" wurde schon vorher bearbeitet.
	    case ASCII_4:
		steuerbit_neu+=ZUFALLSZAHL();//0 oder 1 per zufall erzeugen. Die Funktion "zufallszahl()" gibt nur 1 oder 0 zurueck.
		break;
	    case ASCII_5:
		break;// Bit Toggeln
	    default://Eigentlich nicht moeglich, aber sicher ist sicher!
		L_DE{cout<<"Unbekannest Zeichen!?! :\""<<eingabe_opt_s[i]<<"\"\n";}
		L_EN{cout<<"Unknown character!?! :\""<<eingabe_opt_s[i]<<"\"\n";}
		ENDE_FEHLER();
	}
	if(i!=7){steuerbit_neu<<=1;}//Die Bits um 1 nach rechts verschieben.
    }//Ende der Verarbeitungsschleife
    
    steuerbit_neu=steuerbit_neu|steuerbit_alt;//Mit hilfe des OR-Operators den endgueltigen Wert zum senden erzeugen.
    return steuerbit_neu;

}//Ende von OPT_S_2
//**********************************************************************************
void OPT_S_3(unsigned char relaiskarte,unsigned char steuerbit)
{
    unsigned char temp=0;
    unsigned char daten_senden[SENDEN_EINFACH_DATENLAENGE];
    daten_senden[0]=CMD_SET_PORT_S;
    daten_senden[1]=relaiskarte;
    daten_senden[2]=steuerbit;
    daten_senden[3]=(daten_senden[0]^daten_senden[1]^daten_senden[2]);
    SENDEN(daten_senden,SENDEN_EINFACH_DATENLAENGE);
    
    temp=EMPFANG_EINFACH(0,0);
    if (temp!=EMPFANG_EINFACH_DATENLAENGE){
	L_DE{cout<<"Habe nicht "<<EMPFANG_EINFACH_DATENLAENGE<<", sondern \""<<int(temp)<<"\" Bytes empfangen!\n";}
	L_EN{cout<<"I've received \""<<int(temp)<<"\" and not \""<<EMPFANG_EINFACH_DATENLAENGE<<"\" bytes\n";}
	ENDE_FEHLER();
    }

    if (empfang_einfach_daten[0]==CMD_SET_PORT_R)
    {
	if (empfang_einfach_daten[3]==(empfang_einfach_daten[0]^empfang_einfach_daten[1]^empfang_einfach_daten[2]))
	{
	    if (empfang_einfach_daten[2]==steuerbit)
	    {
		L_DE{cout<<"OK\n";}
		L_EN{cout<<"OK\n";}
	    }
	    else {
		L_DE{cout<<"Fehler\n";}
		L_EN{cout<<"Error\n";}
		ENDE_FEHLER();
	    }
	}
	else {
	    L_DE{cout<<"Fehlerhafte Pruefsumme!\n";}
	    L_EN{cout<<"Wrong checksum!\n";}
	    ENDE_FEHLER();
	}
    }
    else
    {
	if (empfang_einfach_daten[0]==CMD_SET_PORT_S){
	    L_DE{cout<<"Fehlerhafte Initialisierung oder Falsche Relaiskartennummer?\n";}
	    L_EN{cout<<"Wrong initialisation or relaiscardnumber?\n";}
	    ENDE_FEHLER();
	}
	else {
	    L_DE{cout<<"Unbekannte Daten empfangen!\n";}
	    L_EN{cout<<"Unkown data received!\n";}
	    ENDE_FEHLER();
	}
    }
}//Ende von OPT_S_3
//**********************************************************************************
void OPT_G_1(unsigned char relaiskarte)
{
    bool status=0;
    unsigned char temp=0;
    unsigned char daten_senden[SENDEN_EINFACH_DATENLAENGE];
    int i=0;
    daten_senden[0]=CMD_GET_PORT_S;
    daten_senden[1]=relaiskarte;
    daten_senden[2]=0;
    daten_senden[3]=(daten_senden[0]^daten_senden[1]^daten_senden[2]);
    status=SENDEN(daten_senden,SENDEN_EINFACH_DATENLAENGE);
    temp=EMPFANG_EINFACH(0,0);
    if (temp!=EMPFANG_EINFACH_DATENLAENGE){
	L_DE{cout<<"Habe nicht "<<EMPFANG_EINFACH_DATENLAENGE<<", sondern \""<<int(temp)<<"\" Bytes empfangen!\n";}
	L_EN{cout<<"I've received \""<<int(temp)<<"\" and not \""<<EMPFANG_EINFACH_DATENLAENGE<<"\" bytes\n";}
	ENDE_FEHLER();
    }
    if (empfang_einfach_daten[0]==CMD_GET_PORT_R)
    {
	if (empfang_einfach_daten[3]==(empfang_einfach_daten[0]^empfang_einfach_daten[1]^empfang_einfach_daten[2]))
	{
	    for (i=0,temp=0x01;i<EINGABE_OPT_S_STRINGLAENGE;temp<<=1,i++)//Diese Schleife erzeugt die Ausgabe, ob das jeweilige Relais aus oder ein ist.
	    {
		L_DE{cout<<"Relais "<<i+1<<" = ";}
		L_EN{cout<<"relais "<<i+1<<" = ";}
		if (temp&empfang_einfach_daten[2]){
		    L_DE{cout<<"ein";}
		    L_EN{cout<<"on";}
		}
		else {
		    L_DE{cout<<"aus";}
		    L_EN{cout<<"off";}
		}
		cout<<"\n";
	    }
	}
	else {
	    L_DE{cout<<"Fehlerhafte Pruefsumme!\n";}
	    L_EN{cout<<"Wrong checksum!\n";}
	    ENDE_FEHLER();
	}
    }
    else
    {
	if (empfang_einfach_daten[0]==CMD_GET_PORT_S){
	    L_DE{cout<<"Fehlerhafte Initialisierung oder Falsche Relaiskartennummer?\n";}
	    L_EN{cout<<"Wrong initialisation or relaiscardnumber?\n";}
	    ENDE_FEHLER();
	}
	else {
	    L_DE{cout<<"Unbekannte Daten empfangen!\n";}
	    L_EN{cout<<"Unkown data received!\n";}
	    ENDE_FEHLER();
	}
    }
	
}//Ende von OPT_G_1
//**********************************************************************************
void OPT_I_1()
{
    bool status=0;
    unsigned int i=0;
    unsigned int relaikarten_anzahl=0;
    unsigned char daten_senden[SENDEN_EINFACH_DATENLAENGE];
    daten_senden[0]=CMD_SETUP_S;
    daten_senden[1]=1;
    daten_senden[2]=0;
    daten_senden[3]=(daten_senden[0]^daten_senden[1]^daten_senden[2]);
    status=SENDEN(daten_senden,SENDEN_EINFACH_DATENLAENGE);
    relaikarten_anzahl=EMPFANG_ERWEITERT(10,0);//Die 10 ist zum schnelleren Initialisieren!
    
    if (relaikarten_anzahl==0){
	L_DE{cout<<"Es wurden keine Relaiskarten gefunden! :-(\n";}
	L_EN{cout<<"No relaiscards found! :-(\n";}
	ENDE_FEHLER();
    }
    
    if (relaikarten_anzahl==2){
	L_DE{cout<<"Es wurde theoretisch \""<<relaikarten_anzahl-1<<"\" Relaiskarte gefunden! :-)\nStarte mit der Ueberpruefung!\n";}
	L_EN{cout<<"Found \""<<relaikarten_anzahl-1<<"\" relaiscard! :-)\nStart checking!\n";}
    }
    else {
	L_DE{cout<<"Es wurden theoretisch \""<<relaikarten_anzahl-1<<"\" Relaiskarten gefunden! :-)\nStarte mit der Ueberpruefung!\n";}
	L_EN{cout<<"Found \""<<relaikarten_anzahl-1<<"\" relaiscards! :-)\nStart checking!\n";}
    }

    for (i=0;i<relaikarten_anzahl;i++)
    {
	if (empfang_erweitert_daten[i][0]==CMD_SETUP_R &&
	    empfang_erweitert_daten[i][3]==(empfang_erweitert_daten[i][0]^empfang_erweitert_daten[i][1]^empfang_erweitert_daten[i][2]))
	{
	    L_DE{cout<<"Relaiskarte "<<i+1<<"\tAdresse="<<int(empfang_erweitert_daten[i][1])<<" INFO=0x"<<hex<<int(empfang_erweitert_daten[i][2])<<dec<<endl;}
	    L_EN{cout<<"Relaiscard "<<i+1<<"\taddress="<<int(empfang_erweitert_daten[i][1])<<" INFO=0x"<<hex<<int(empfang_erweitert_daten[i][2])<<dec<<endl;}
	}
	else
	{
	    if (empfang_erweitert_daten[i][0]==CMD_SETUP_S &&
	    empfang_erweitert_daten[i][3]==(empfang_erweitert_daten[i][0]^empfang_erweitert_daten[i][1]^empfang_erweitert_daten[i][2]))
	    {
		L_DE{cout<<"Abschlusssignal = ";}
		L_EN{cout<<"Finalmessage = ";}
		if (empfang_erweitert_daten[i][1]==relaikarten_anzahl)
		{
		    L_DE{cout<<"OK";}
		    L_EN{cout<<"OK";}
		}
		else{
		    L_DE{cout<<"Fehler";}
		    L_EN{cout<<"error";}
		}
		cout<<"!\n";
	    }
	    else{
		L_DE{cout<<"Unbekanntes Signal!\n";}
		L_EN{cout<<"Unknown message!\n";}
	    }
	}
    }
}//Ende von OPT_I_1
//**********************************************************************************
void OPT_D_1()
{
comport=&optarg[0];
}//Ende von OPT_D_1
//**********************************************************************************
void ENDE_FEHLER(void)
{
    L_DE{cout<<"Das Programm wird auf Grund eines Fehlers beendet.\n";}
    L_EN{cout<<"The programme terminated due to an error.\n";}
    exit(1);
}
//**********************************************************************************
void OPT_F_1()//Short check of input parameters and then a copy into eingabe_opt_s for later processing 
{
    int i=0;
    memset(eingabe_opt_f,0x00,EINGABE_OPT_F_STRINGLAENGE);

    for (i=0;i<MAX_PARAMETER;i++){if (optarg[i]==0x00){break;}}//Zaehlen der Eingabeoptionen fuer -f - count the number of parameters for -f

    if (i==EINGABE_OPT_F_STRINGLAENGE)
    {
        for (i=0;i<EINGABE_OPT_F_STRINGLAENGE;i++)
        {eingabe_opt_f[i]=optarg[i];}
    }
    else
    {
	L_DE{cout<<"Sie haben \""<<i<<"\" optionen angegeben anstatt \""<<EINGABE_OPT_F_STRINGLAENGE<<"\"!\n";}
        L_EN{cout<<"You gave \""<<i<<"\" options instead of the required \""<<EINGABE_OPT_F_STRINGLAENGE<<"\"!\n";}
        ENDE_FEHLER();
    }

}//Ende von OPT_F_1
//*********************************************************************************

unsigned char OPT_F_2(unsigned char relaiskarte)//Verarbeitung der Eingabeparameter, welche in eingabe_opt_f gespeichert sind.
{
    int i=0,i2=0,random=0;
    unsigned char steuerbit_neu=0,steuerbit_an=0,steuerbit_aus=0xFF,steuerbit_alt=0;
    int relaisswitch=0, relaisbit=0;

//here some code is inserted to assign the left value of the string to 'relaisnumber'. The second part must be checked against the ascii values

     relaisswitch=eingabe_opt_f[0]-48;

     if ((relaisswitch<1 || relaisswitch>8))
	{
	    L_DE{cout<<"Geben Sie eine Nummer zwischen 1 und 8 an\n";}
	    L_EN{cout<<"Give a number between 1 and 8\n";}
	    ENDE_FEHLER();
	}
     if (eingabe_opt_f[1]!=ASCII_1 && eingabe_opt_f[1]!=ASCII_2 && eingabe_opt_f[1]!=ASCII_3 && eingabe_opt_f[1]!=ASCII_4 && eingabe_opt_f[1]!=ASCII_5)//checking the numbers
        {
    	    L_DE{cout<<"Falscher Parameter: \""<<eingabe_opt_s[1]<<"\n";}
    	    L_EN{cout<<"Wrong Parameter: \""<<eingabe_opt_s[1]<<"\n";}
	    ENDE_FEHLER();
	}
     
	//inverting the relaisswitch into the appropiate bitnumber

     switch (relaisswitch)
	{
	case 1 :
		relaisbit=7;
		break;
	case 2 :
		relaisbit=6;
		break;
	case 3 :
		relaisbit=5;
		break;  
   	case 4 :
		relaisbit=4;
		break;
	case 5 :
		relaisbit=3;
		break;
	case 6 :
		relaisbit=2;
		break;
	case 7 :
		relaisbit=1;
		break;
	case 8 :
		relaisbit=0;
		break;
	}
//   cout<<"\n the relaynumber is "<<relaisswitch<<" en the relaybit is "<<relaisbit<<"\n\n";
     
     steuerbit_alt=GET_STATUS(relaiskarte);//Hier wird der Aktuelle Relaisstatus abgefragt. - Get the original relais status	

    for (steuerbit_an=0x00,steuerbit_aus=0x00,i=0;i<EINGABE_OPT_S_STRINGLAENGE;i++)//Umwandlung des Strings in ein unsigned char.
    {
        steuerbit_aus++;//This one always counts, except when:
	if (relaisbit==i) {
	  switch (eingabe_opt_f[1])//Abfrage, welches Zeichen gerade vorhanden ist.
        	 {
            case ASCII_1:
	   	steuerbit_aus--;
               	break;//Set to 0 lassen.
            case ASCII_2:
            	steuerbit_an++;//Auf 1 setzen
                break;
            case ASCII_3:
		break;//nichts machen - do nothing
            case ASCII_4:
		random=ZUFALLSZAHL(); //"zufallszahl()" is a randomgenerator, returning either 1 or 0
		if (random==1) {steuerbit_an++;}
		else {steuerbit_aus--;}
		break;
            case ASCII_5:
                i2=1; //togglebit setzen
		steuerbit_an++;
		steuerbit_aus--;
		break;// Bit Toggeln
            default://Eigentlich nicht moeglich, aber sicher ist sicher!
                L_DE{cout<<"Unbekannest Zeichen!?! :\""<<eingabe_opt_f[1]<<"\"\n";}
                L_EN{cout<<"Unknown character!?! :\""<<eingabe_opt_f[1]<<"\"\n";}
                ENDE_FEHLER();
				}
			}     	
			
			if (i!=7) {
				steuerbit_an<<=1;//Die Bits um 1 nach rechts verschieben.
				steuerbit_aus<<=1;
			}
	}//Ende der Verarbeitungsschleife
	
   

	if (i2!=0){
		//apparently it was a toggle!
		if (steuerbit_alt&steuerbit_an){ //the relay was on (and has to be switched off)
			steuerbit_neu=steuerbit_alt&steuerbit_aus;
		}
		else {steuerbit_neu=steuerbit_alt|steuerbit_an;
		}
	}
	else {
		steuerbit_neu=steuerbit_alt|steuerbit_an;
		steuerbit_neu=steuerbit_neu&steuerbit_aus;
	}

//steuerbit_neu=steuerbit_neu|steuerbit_alt;//Mit hilfe des OR-Operators den endgueltigen Wert zum senden erzeugen.
    return steuerbit_neu;

}//Ende von OPT_F_2
//*********************************************************************************************`
